/* Fisheyeitem.java

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Thu Dec 29 20:49:04     2005, Created by tomyeh
}}IS_NOTE

Copyright (C) 2005 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package org.zkforge.dojo;

import org.zkoss.lang.Objects;
import org.zkoss.xml.HTMLs;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.AbstractComponent;
import org.zkoss.zk.ui.UiException;

/**
 * A fisheye item.
 *
 * @author tomyeh
 * @version $Revision: 1.7 $ $Date: 2006/03/17 10:36:24 $
 * @see Fisheyelist
 */
public class Fisheyeitem extends AbstractComponent {
	private String _image, _label = "";

	/** Returns the label (never null).
	 * <p>Default: "".
	 */
	public String getLabel() {
		return _label;
	}
	/** Sets the label.
	 */
	public void setLabel(String label) {
		if (label == null) label = "";
		if (!Objects.equals(_label, label)) {
			_label = label;
			smartUpdate("dojo.caption", _label);
		}
	}
	/** Returns the image URI.
	 * <p>Default: null.
	 */
	public String getImage() {
		return _image;
	}
	/** Sets the image URI.
	 */
	public void setImage(String image) {
		if (image != null && image.length() == 0) image = null;
		if (!Objects.equals(_image, image)) {
			_image = image;
			smartUpdate("dojo.iconsrc", _image);
		}
	}

	/** Returns the HTML attributes for this component.
	 * <p>Used only for component development, not for application developers.
	 */
	public String getOuterAttrs() {
		final StringBuffer sb = new StringBuffer(128);
		HTMLs.appendAttribute(sb, "dojo:iconsrc",
			getDesktop().getExecution().encodeURL(
				_image != null ? _image: "~./img/spacer.gif"));
		HTMLs.appendAttribute(sb, "dojo:caption", _label);
		return sb.toString();
	}

	//-- Component --//
	public void smartUpdate(String attr, String value) {
		//FUTURE: use JavaScript to control
		final Component p = getParent();
		if (p != null)
			p.invalidate();
	}
	public void setParent(Component parent) {
		if (parent != null && !(parent instanceof Fisheyelist))
			throw new UiException("Unsupported parent for fisheyeitem: "+parent);
		super.setParent(parent);
	}
	/** Not childable. */
	public boolean isChildable() {
		return false;
	}
}
